﻿Type=Class
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Sub Class_Globals
	Type PointApi(x As Float, y As Float)
	Type RGBColor(Alpha As Short, Red As Short,	Green As Short, Blue As Short)
	Private cvPanel As Canvas
	Private pnRoot As Panel
	Private myRect As Rect
	Private Center As PointApi
	Private lft, top, wdt, hgt As Int
	Private Scale As Float
	Private ivPanel As ImageView	
	Private ivIndicator As ImageView
	Private ivShadow As ImageView
	Private Bmp As Bitmap
	Private tmIndic As Timer 
	Private SpeedValue, SpeedOldValue As Float
	Private Direction As Short
	Private lbF As Label
	Private lbC As Label
	Private clrFahrenheit As Int
	Private clrCelsius As Int
	Private clrIndicator As Int
	Private  GradientOrientation  As String
	Private GradientColors() As Int
	Private CornerRadius As Float
	Private GradientShape As Int
	Private GradientType As Int
End Sub

'Activity, left, top, Scale  
'Scale = percent
Public Sub Initialize(Act As Activity, l As Int, t As Int, Sc As Float)
	Scale = Sc/100
	lft = l
	top = t
	wdt = 300dip * Scale					'Object size
	hgt = 300dip * Scale
	Center.x = wdt / 2						'Object Center
	Center.y = hgt / 2
	pnRoot.Initialize("")
	clrFahrenheit = Colors.RGB(0, 0, 100) 	'Colors
	clrCelsius = Colors.RGB(0, 100, 0)
	clrIndicator = Colors.RGB(100, 0, 0)
	
	tmIndic.Initialize("tmIndic", 10)
	tmIndic.Enabled = False
	Dim lf, tp, wd, hg As Float
	lf = Center.x -10dip * Scale
	tp =	Center.y - 90dip * Scale
	wd = 20dip * Scale
	hg = 180dip * Scale 
	
	'Panel ImageView
	ivPanel.Initialize("")
	pnRoot.AddView(ivPanel, 0, 0, wdt, hgt)
	
	'labels for the Panel - Fahrenheit and Celsius
	lbF.Initialize("")			'			
	lbF.Gravity = Gravity.CENTER
	lbF.Typeface = Typeface.DEFAULT_BOLD
	lbF.TextSize = 13 * Scale
	lbF.TextColor = clrFahrenheit
	pnRoot.AddView(lbF, Center.x - 30dip * Scale, Center.y + 25dip * Scale, 60dip * Scale, 20dip * Scale) 
	lbC.Initialize("")
	lbC.Gravity = Gravity.CENTER
	lbC.Typeface = Typeface.DEFAULT_BOLD
	lbC.TextSize = 13 * Scale
	lbC.TextColor = clrCelsius
	pnRoot.AddView(lbC, Center.x - 30dip * Scale, Center.y + 45dip * Scale, 60dip * Scale, 20dip * Scale) 

	ivShadow.Initialize("")
	pnRoot.AddView(ivShadow, lf + 5dip * Scale, tp + 5dip * Scale, wd, hg)

	'Indicator ImageView
	ivIndicator.Initialize("")
	pnRoot.AddView(ivIndicator, lf, tp, wd, hg)
	Act.AddView(pnRoot, lft, top, wdt, hgt)
	DrawPanel
End Sub

private Sub DrawPanel
	cvPanel.Initialize(ivPanel)
	Dim Obj1 As Reflector
	Obj1.Target = cvPanel
   	Obj1.Target = Obj1.GetField("paint")
   	Obj1.RunMethod2("setAntiAlias", True, "java.lang.boolean")	
	Dim Radius As Float = wdt * 0.5
	'Initialize Panel
	Bmp.InitializeMutable(ivPanel.Width, ivPanel.Height)
	myRect.Initialize(0, 0, ivPanel.Width, ivPanel.Height)
	cvPanel.DrawRect(myRect, Colors.Transparent, True, 0)
	cvPanel.DrawBitmap(Bmp, myRect, myRect)
	'Create Gradient
	Dim CenterGX As Float, CenterGY As Float
	GradientOrientation = "TL_BR"
	GradientColors = Array As Int (Colors.White, Colors.LightGray, Colors.Gray)
	CornerRadius = 10dip
	GradientShape = 1
	GradientType = 1
	CenterGX = 0.3
	CenterGY = 0.3
	Dim Cdw As ColorDrawable
	Cdw = Drawables.GradDrawable(GradientOrientation, GradientColors, CornerRadius, GradientShape, GradientType, Radius, CenterGX, CenterGY)
	cvPanel.DrawDrawable(Cdw, myRect)
'	'Main Panel
	Dim RdPanel As Float = Radius -20dip * Scale 
	cvPanel.DrawCircle(Center.x, Center.y, RdPanel, Colors.White, True, 1)
	cvPanel.DrawCircle(Center.x, Center.y, RdPanel, Colors.Gray, False, 1)
    Dim  txtPos As Short
    Dim  markSize(5) As Float
	markSize(0)= 12dip * Scale
	markSize(1)= 20dip * Scale
	markSize(2)= 34dip * Scale
	markSize(3)= 40dip * Scale	
	markSize(4)= 30dip * Scale
    Dim  TickCount, Tickval As Short
	Dim NewPt(2) As PointApi 
	For TickCount = 0 To 240 Step 2
		Tickval = TickCount - 120
		NewPt(0)= new_pt(Tickval ,RdPanel, Center.x, Center.y)
		If (TickCount/2) Mod 10 = 0 Then
			NewPt(1) = new_pt(Tickval, RdPanel - markSize(1),Center.x,Center.y)
		Else If (TickCount/2) Mod 5 = 0 Then
			NewPt(1) = new_pt(Tickval, RdPanel - markSize(4),Center.x,Center.y)
		Else
			NewPt(1) = new_pt(Tickval, RdPanel - markSize(0),Center.x,Center.y)
		End If
		cvPanel.DrawLine(NewPt(0).x, NewPt(0).y ,NewPt(1).x,NewPt(1).y, Colors.DarkGray, 1)
	Next
	cvPanel.DrawCircle(Center.x ,Center.y, RdPanel-markSize(2), Colors.DarkGray, False, 1)
	For TickCount = 0 To 240 Step 2
		Tickval = TickCount - 120
        txtPos = TickCount/2 Mod 10
        If txtPos = 0 Then
			markSize(3)= 50dip * Scale	
			NewPt(1) = new_pt(360-Tickval,RdPanel - markSize(4),Center.x,Center.y)
			NewPt(0) = new_pt(360-Tickval,RdPanel - markSize(3) ,Center.x,Center.y)
			cvPanel.DrawTextRotated((TickCount/2), NewPt(1).x , NewPt(1).y, Typeface.DEFAULT_BOLD, 12 * Scale,clrFahrenheit, "CENTER", TickCount-120)
		End If
       	Dim celsius As  Float = ((TickCount/2)-32)/1.80
	   	If celsius mod 10 = 0 Then
			NewPt(0) = new_pt(360-Tickval,RdPanel - markSize(3) ,Center.x,Center.y)
			cvPanel.DrawTextRotated(NumberFormat(celsius, 1, 1), NewPt(0).x , NewPt(0).y, Typeface.DEFAULT, 12 * Scale, clrCelsius, "CENTER", TickCount-120)
		End If
	Next
	myRect.Initialize(20dip * Scale, 20dip * Scale, RdPanel * 2 + 20dip * Scale,  RdPanel * 2 + 20dip * Scale)
	GradientOrientation = "TR_BL"
	GradientColors = Array As Int (Colors.Transparent, Colors.Transparent, Colors.Transparent, Colors.ARGB(128, 0, 0, 0))
	GradientShape = 1
	GradientType = 1
	CenterGX = 0.5
	CenterGY = 0.5
	Dim Cdw As ColorDrawable
	Cdw = Drawables.GradDrawable(GradientOrientation, GradientColors, CornerRadius, GradientShape, GradientType, Radius, CenterGX, CenterGY)
	cvPanel.DrawDrawable(Cdw, myRect)
	cvPanel.DrawText("Fahrenheit",Center.x, 100dip * Scale,Typeface.DEFAULT_BOLD,12 * Scale, clrFahrenheit,"CENTER")
	cvPanel.DrawText("Celsius",Center.x, 120dip * Scale,Typeface.DEFAULT, 12 * Scale, clrCelsius,"CENTER")
	DrawIndicator
End Sub

private Sub DrawIndicator
	myRect.Initialize(0, 0, ivShadow.Width, ivShadow.Height)
	Bmp.InitializeMutable(ivShadow.Width, ivShadow.Height)
	cvPanel.Initialize(ivShadow)

	cvPanel.DrawRect(myRect, Colors.Transparent, True, 0)
	cvPanel.DrawBitmap(Bmp, myRect, myRect)
	Center.x = ivShadow.Width * 0.5
	Center.y = ivShadow.Height  * 0.5	
	Dim rect As Rect
	rect.Initialize(Center.x -5dip * Scale , Center.y + 9dip * Scale, Center.x + 5dip * Scale, Center.y + 25dip * Scale)
	cvPanel.DrawRect(rect, Colors.ARGB(96, 128, 128, 128), True, 0)

	Dim path As Path
	path.Initialize(Center.x - 5dip * Scale, Center.y -9dip * Scale)
	path.LineTo(Center.x, Center.y - 90dip * Scale)
	path.LineTo(Center.x + 5dip * Scale, Center.y -9dip * Scale)
	path.LineTo(Center.x - 5dip * Scale, Center.y -9dip * Scale)
	cvPanel.DrawPath(path, Colors.ARGB(96, 128, 128, 128), True, 1)
	cvPanel.DrawCircle(Center.x, Center.y, 10dip * Scale, Colors.ARGB(96, 128, 128, 128), True, 0)

	myRect.Initialize(0, 0, ivIndicator.Width, ivIndicator.Height)
	Bmp.InitializeMutable(ivIndicator.Width, ivPanel.Height)
	cvPanel.Initialize(ivIndicator)
	Dim Obj1 As Reflector
	Obj1.Target = cvPanel
   	Obj1.Target = Obj1.GetField("paint")
   	Obj1.RunMethod2("setAntiAlias", True, "java.lang.boolean")		
	
	cvPanel.DrawRect(myRect, Colors.Transparent, True, 0)
	cvPanel.DrawBitmap(Bmp, myRect, myRect)
	Center.x = ivIndicator.Width * 0.5
	Center.y = ivIndicator.Height  * 0.5	
	Dim rect As Rect
	rect.Initialize(Center.x -5dip * Scale , Center.y + 9dip * Scale, Center.x + 5dip * Scale, Center.y + 25dip * Scale)
	cvPanel.DrawRect(rect, clrIndicator, True, 1)
	cvPanel.DrawRect(rect, Colors.Gray, False, 2)

	Dim path As Path
	path.Initialize(Center.x - 5dip * Scale, Center.y -9dip * Scale)
	path.LineTo(Center.x, Center.y - 90dip * Scale)
	path.LineTo(Center.x + 5dip * Scale, Center.y -9dip * Scale)
	path.LineTo(Center.x - 5dip * Scale, Center.y -9dip * Scale)
	cvPanel.DrawPath(path, clrIndicator, True, 1)
	cvPanel.DrawPath(path, Colors.Gray, False, 2)
	cvPanel.DrawCircle(Center.x, Center.y, 10dip * Scale, clrIndicator, True, 0)
	cvPanel.DrawCircle(Center.x, Center.y, 10dip * Scale, Colors.Gray, False, 2)
	SpeedOldValue = 60
	Set_Fahrenheit_Value(0)
End Sub

Private Sub new_pt(nAngle As Double, r As Double, CX  As Double, CY As Double ) As PointApi 
        Dim AngleRad As Double
		Dim pt As PointApi 
		nAngle = 90 + nAngle
        If nAngle > 360 Then nAngle = nAngle - 360
        AngleRad = nAngle * cPI / 180 'convert to rad
        If AngleRad < 0 Then AngleRad = 6.283 + AngleRad
        pt.x = CX + (r) * Cos(AngleRad)
        pt.Y  = CY - (r) * Sin(AngleRad)
        Return pt
End Sub

Public Sub Set_Fahrenheit_Value(vl As Float)
	vl = Min(Max(0, vl), 120)
	SpeedValue = vl * 2
	If SpeedValue < SpeedOldValue Then 
		Direction = -1
	Else if SpeedValue > SpeedOldValue Then
		Direction = 1
	Else 
		Return
	End If
	tmIndic.Enabled =True	
End Sub

Private Sub tmIndic_Tick
	SpeedOldValue = SpeedOldValue + Direction
	If Direction = -1 Then
		If SpeedOldValue <= SpeedValue Then
			SpeedOldValue = SpeedValue
			tmIndic.Enabled = False
		End If
	Else
		If SpeedOldValue >= SpeedValue Then
			SpeedOldValue = SpeedValue
			tmIndic.Enabled = False
		End If
	End If
	lbF.Text = NumberFormat2((SpeedOldValue / 2), 1, 2, 2, False)  & " ºF"
	lbC.Text = NumberFormat2(((SpeedOldValue / 2)-32)/1.800, 1, 2, 2, False)  & " ºC"
	Dim angle As Float = SpeedOldValue - 120
	setRotation(ivIndicator, angle)
	setRotation(ivShadow, angle)
End Sub

Private Sub setRotation(v As View, Angle As Float)
    Dim jo = v As JavaObject
    jo.RunMethod("setRotation", Array As Object(Angle))
End Sub